import { List, Map } from "immutable";
import { TypeGraphBuilder } from "./TypeBuilder";
export declare enum PathElementKind {
    Root = 0,
    Definition = 1,
    OneOf = 2,
    AnyOf = 3,
    Property = 4,
    AdditionalProperty = 5,
    Items = 6,
}
export declare type PathElement = {
    kind: PathElementKind.Root;
} | {
    kind: PathElementKind.Definition;
    name: string;
} | {
    kind: PathElementKind.OneOf;
    index: number;
} | {
    kind: PathElementKind.AnyOf;
    index: number;
} | {
    kind: PathElementKind.Property;
    name: string;
} | {
    kind: PathElementKind.AdditionalProperty;
} | {
    kind: PathElementKind.Items;
};
export declare type Ref = List<PathElement>;
export declare const rootRef: Ref;
export declare function addTypesInSchema(typeBuilder: TypeGraphBuilder, rootJson: any, conflateNumbers: boolean, references: Map<string, Ref>): void;
export declare function definitionRefsInSchema(rootJson: any): Map<string, Ref>;
