"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function isValidJSON(s) {
    try {
        JSON.parse(s);
        return true;
    }
    catch (error) {
        return false;
    }
}
function sourcesFromPostmanCollection(collectionJSON) {
    var sources = [];
    function processCollection(c) {
        if (typeof c !== "object")
            return;
        if (Array.isArray(c.item)) {
            for (var _i = 0, _a = c.item; _i < _a.length; _i++) {
                var item = _a[_i];
                processCollection(item);
            }
        }
        if (typeof c.name === "string" && Array.isArray(c.response)) {
            var samples = [];
            for (var _b = 0, _c = c.response; _b < _c.length; _b++) {
                var r = _c[_b];
                if (typeof r === "object" && typeof r.body === "string" && isValidJSON(r.body)) {
                    samples.push(r.body);
                }
            }
            if (samples.length > 0) {
                sources.push({ name: c.name, samples: samples });
            }
        }
    }
    processCollection(JSON.parse(collectionJSON));
    console.log("sources are", JSON.stringify(sources));
    return sources;
}
exports.sourcesFromPostmanCollection = sourcesFromPostmanCollection;
