import { Map } from "immutable";
export declare class TypeAttributeKind<T> {
    readonly name: string;
    readonly combine: (a: T, b: T) => T;
    constructor(name: string, combine: ((a: T, b: T) => T) | undefined);
    makeAttributes(value: T): TypeAttributes;
    tryGetInAttributes(a: TypeAttributes): T | undefined;
    setInAttributes(a: TypeAttributes, value: T): TypeAttributes;
    modifyInAttributes(a: TypeAttributes, modify: (value: T | undefined) => T | undefined): TypeAttributes;
    setDefaultInAttributes(a: TypeAttributes, makeDefault: () => T): TypeAttributes;
    equals(other: any): boolean;
    hashCode(): number;
}
export declare type TypeAttributes = Map<TypeAttributeKind<any>, any>;
export declare function combineTypeAttributes(attributeArray: TypeAttributes[]): TypeAttributes;
export declare const descriptionTypeAttributeKind: TypeAttributeKind<string>;
export declare const propertyDescriptionsTypeAttributeKind: TypeAttributeKind<Map<string, string>>;
